SystemOrganization addCategory: #'CS520-hm1'!

NamedBox subclass: #DancingBox
	instanceVariableNames: 'numberOfStepsInDance currentDanceStep danceMoves danceSpeed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-hm1'!

!DancingBox methodsFor: 'initialization' stamp: 'CameronRieck 1/13/2013 19:56'!
initialize
	"initializes the dancing box"
	super initialize.
	super stopStepping.
	danceSpeed := 0.
	danceMoves := LinkedList new.
	danceMoves add: 10@0.
	danceMoves add: 0@(-10).
	danceMoves add: -10@0.
	danceMoves add: 0@10.
	currentDanceStep := 1.! !

!DancingBox methodsFor: 'dancing' stamp: 'CameronRieck 1/13/2013 19:57'!
startDancing
	"moves the box according to a dance move"
	currentDanceStep := 1.
	danceSpeed := 750.
	super startStepping.! !

!DancingBox methodsFor: 'dancing' stamp: 'CameronRieck 1/13/2013 19:59'!
step
	"implements what needs to be done during a dance step"
	| danceMove |
	super step.
	(danceSpeed > 0) ifTrue: 
		[
		danceMove := danceMoves at: currentDanceStep.
		self move:danceMove.
		currentDanceStep := (currentDanceStep + 1).
		(currentDanceStep > danceMoves size) ifTrue: [currentDanceStep := 1].
		]! !

!DancingBox methodsFor: 'dancing' stamp: 'CameronRieck 1/13/2013 19:55'!
stepTime
	"comment stating purpose of message"
	^ danceSpeed.! !

!DancingBox methodsFor: 'dancing' stamp: 'CameronRieck 1/13/2013 19:57'!
stopDancing
	"stops dancing"
	super stopStepping.
	danceSpeed := 0.! !
